#ifndef DEF_APP
#define DEF_APP

#include "player.h"

enum SCENES
{
	S_NONE,
	S_INTRO,
	S_TITLE,
	S_H1,
	S_H1_I,
	S_H2,
	S_H2_I,
	S_H3,
	S_H3_I,
	S_TUNNEL,
	S_H4_1,
	S_H4_2,
	S_CHURCH,
	S_CHURCH_I,
	S_HOSPITAL,
	S_COUNT
};

class Application
{
	public:
		Application();
		int Exec();
		void Draw();
		void Script();
		void HandleEvent();
		void SetScene(int NewScene, bool fade = false);
		~Application();

		int GetScene() const;
		int GetFade() const;
		sf::Vector2<float> GetCursorPosition() const;
		sf::RenderWindow* GetRenderWindow();
	
	private:
		sf::RenderWindow _RWindow;

		sf::Sprite _CursorSprite;
		sf::Image _CursorImage;
		sf::Vector2<float> _CursorPosition;

		sf::Image _BGImage;
		sf::Image _FGImage;
		sf::Image _DImage;
		sf::Image _FilterImage;
		sf::Image _FogImage;

		sf::Sprite _BGSprite;
		sf::Sprite _FGSprite;
		sf::Sprite _DSprite;
		sf::Sprite _FilterSprite;
		sf::Sprite _FogSprite;

		sf::Image _FadeImage;
		sf::Sprite _FadeSprite;

		sf::Image _DoorImage;
		sf::Image _TunnelImage;
		sf::Image _BedImage;
		sf::Sprite _DoorSprite;
		sf::Sprite _TunnelSprite;
		sf::Sprite _BedSprite;

		Sound _CorruptionSound;
		Sound _HeartbeatSound;
		Sound _BipSound;
		Sound _LightSound;

		Sound _CellMusic;
		Sound _CavernMusic;
		Sound _TunnelMusic;

		Player _Player;
		sf::Vector2<float> _StartPosition;

		int _Scene;
		int _NewScene;
		bool _foreground;

		bool _fullscreen;
		bool _load;
		bool _interact;

		float _timer0, _timer1;

		float _fogTimer;
		int _fogX;

		float _fadeTimer;
		int _fadeLevel;
		int _fade;

		bool _h3corrupted;
		bool _h4corrupted;
};

#endif
