#include "player.h"
#include "application.h"

Player::Player()
{
	_Image.LoadFromFile("data/graphics/cell.png");
	_Image.SetSmooth(false);

	_Sprite.SetImage(_Image);
	_Sprite.SetPosition(50, 50);
	_Sprite.SetCenter(7, 7);

	_CursorPos.x = 0;
	_CursorPos.y = 0;

	_timer = 0.f;
	_frame = 0;
}


void Player::SetApp(Application *App)
{
	_App = App;
	_RWindow = _App->GetRenderWindow();
}


void Player::Display()
{
	static bool sFrame = false;
	sf::Vector2<float> Velocity(0, 0);
	_CursorPos = _App->GetCursorPosition();
	_timer += _RWindow->GetFrameTime();

	if (_timer >= 0.1f)
	{
		if (_CursorPos.x < _Sprite.GetPosition().x - 3) Velocity.x = -2;
		else if (_CursorPos.x > _Sprite.GetPosition().x + 3) Velocity.x = 2;

		if (_CursorPos.y < _Sprite.GetPosition().y - 3) Velocity.y = -2;
		else if (_CursorPos.y > _Sprite.GetPosition().y + 3) Velocity.y = 2;

		if (sFrame)
		{
			_frame = !_frame;
			sFrame = false;
		}
		else sFrame = true;
		_timer = 0.f;

		int rpx = _Sprite.GetPosition().x + Velocity.x;
		int rpy = _Sprite.GetPosition().y + Velocity.y;
		if (rpy < 25 || rpy > 119) Velocity.y = 0;

		int s = _App->GetScene();
		if (s == S_H1_I || s == S_H2_I || s == S_H3_I || s == S_CHURCH_I)
		{
			if (rpx < 25 || rpx > 167) Velocity.x = 0;
		}
		else if (s == S_H1)
		{
			if (rpx < 15) Velocity.x = 0;
		}
		else if (s == S_TUNNEL)
		{
			if (rpx > 167) Velocity.x = 0;
			if (rpy < 36) Velocity.y = 0;
		}
		else if (s == S_H4_1)
		{
			if (rpx > 167) Velocity.x = 0;
			if (rpy < 45) Velocity.y = 0;
		}
		else if (s == S_H4_2)
		{
			if (rpx < 25) Velocity.x = 0;
			if (rpy < 45) Velocity.y = 0;
		}
		else if (s == S_CHURCH)
		{
			if (rpx > 167) Velocity.x = 0;
		}
	}

	_Sprite.SetSubRect(sf::Rect<int>(0, _frame * 16, 16, _frame * 16 + 16));
	if (!_App->GetFade())_Sprite.Move(Velocity);
	_RWindow->Draw(_Sprite);
}


bool Player::GetInside(sf::Rect<int> Box)
{
	
	if (_Sprite.GetPosition().x > Box.Left && _Sprite.GetPosition().x < Box.Right
		&& _Sprite.GetPosition().y > Box.Top && _Sprite.GetPosition().y < Box.Bottom
		&& _CursorPos.x > Box.Left && _CursorPos.x < Box.Right
		&& _CursorPos.y > Box.Top && _CursorPos.y < Box.Bottom)
	{
		return true;
	}
	else return false;
}


sf::Sprite* Player::GetSprite()
{
	return &_Sprite;
}


Player::~Player()
{
}
